<?php
/**
 * Plugin cistyle
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */


function cistyle_style($balise='',$attribut=''){
    $return = '';
    
    if ($balise AND $attribut){
        $balise_et_attribut = $balise.'_'.$attribut;
    
        include_spip('inc/cistyle_commun');
        $cles_et_valeurs = cistyle_tableau_style();
    
        if (isset($cles_et_valeurs[$balise_et_attribut])){
            $return = $cles_et_valeurs[$balise_et_attribut];
        }
    }
    
    return $return;
}


function cistyle_style_tout($prefixe=''){
    $return = '';
    $balise_courante = '';
    
    include_spip('inc/cistyle_commun');
    $cles_et_valeurs = cistyle_tableau_style();
    
    foreach ($cles_et_valeurs AS $cle=>$valeur){
        list($balise,$attribut) = explode('_',$cle);
        if (!$balise_courante){
            $balise_courante = $balise;
            $return .= $prefixe.' '.$balise_courante.'{';
        }
        if ($balise != $balise_courante){
            $balise_courante = $balise;
            $return .= '} '.$prefixe.' '.$balise_courante.'{';
        }
        $return .= $attribut.':'.$valeur.';';
    }

    if ($return){
        $return .= '}';
        
        // si prefixe : cas de la balise body
        if ($prefixe){
            $return = str_replace('body{','{',$return);
        }
        
        // cas des intertitres
        $return = str_replace('intertitre',cistyle_balise_intertitre(),$return);
    }
    
    return '<style>'.$return.'</style>';
}

function cistyle_balise_intertitre($arg=''){
    
    if ($GLOBALS['spip_version_branche']>=4) {
        $return = "h2";
    } else {
        $return = "h3";
    }
    
    if (isset($GLOBALS['debut_intertitre'])){
        if (strpos($GLOBALS['debut_intertitre'],'h2')!==false){
            $return = "h2";
        } elseif (strpos($GLOBALS['debut_intertitre'],'h3')!==false){
            $return = "h3";
        }
    }
    
    return $return;
}

?>