<?php
/**
 * Plugin ciwidget
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

function ciwidget_css($arg=''){
    include_spip('inc/ciwidget_commun');    
    $return = '';
    $types_widget = ciwidget_types_widget();

    foreach ($types_widget AS $cle=>$type_widget) {
        if (isset($type_widget['css']) AND $type_widget['css']=='oui' AND isset($type_widget['id'])){
            $f = ciwidget_charger_fonction_css($type_widget['id']);
            if ($f){
                $return .= $f();
            }
        }
    };
    
    return $return;
}

// le fichier php qui génère la partie CSS du type de widget
// doit se nommer "inc/ciwidget_css_".$typewidget.".php" 
function ciwidget_charger_fonction_css($typewidget) {
        $return = '';
        $dossier = 'inc/';
        $nom = 'ciwidget_css_' . $typewidget;

	if (function_exists($nom)) {
		$return = $nom;
	} else {
            // inclure le fichier
            include_spip($dossier . $nom);
            if (function_exists($nom)) {
                    $return = $nom;
            }
        }

        return $return;
}

function ciwidget_info_progression_etape($en_cours,$nombre_etapes,$type_widget) {
        $phase='etape_';
        $class = '';
        
	$aff_etapes = "<ul id='infos_etapes' class='infos_$phase$en_cours'>";

	for ($etape = 1; $etape <= $nombre_etapes; $etape++) {
                if ($etape == $en_cours) {
                        $class = "on";
                } else {
                        if ($etape > $en_cours) {
                                $class = "prochains";
                        } else {
                                $class = "valides";
                        }
                }

                $aff_etapes .= "<li class='$class'><div class='fond'>";
                $aff_etapes .= ($etape == $en_cours) ? "<strong>" : '';
                $aff_etapes .= "<em>" . _T('etape') . " </em><span class='numero_etape'>$etape</span><em>&nbsp;: </em>";
                $aff_etapes .= typo(_T('ciwidget:widget_'.$type_widget.'_etape'.$etape));
                $aff_etapes .= ($etape == $en_cours) ? "</strong>" : '';
                $aff_etapes .= "</div></li>";
	}
	$aff_etapes .= "</ul>";
	$aff_etapes .= "<br class='nettoyeur' />\n";
        
        $style = "<style>#haut {margin-top:0;}</style>";

	return $style . $aff_etapes;
}

function ciwidget_tableau_id_widgets($arg=''){
    include_spip('inc/ciwidget_commun');    
    $return = array();
    $types_widget = ciwidget_types_widget();

    foreach ($types_widget AS $cle=>$type_widget) {
        if (isset($type_widget['id'])){
            $return[$type_widget['id']] = $type_widget['id'];
        }
    };
    
    return $return;
}

function ciwidget_tableau_id_widgets_concerne_grpd($arg=''){
    include_spip('inc/ciwidget_commun');    
    $return = array();
    $types_widget = ciwidget_types_widget();

    foreach ($types_widget AS $cle=>$type_widget) {
        if (isset($type_widget['id'])){
            if (isset($type_widget['concerne_rgpd']) AND $type_widget['concerne_rgpd']=='oui'){
                $return[$type_widget['id']] = $type_widget['id'];
            }
        }
    };
    
    return $return;
}

function ciwidget_tableau_id_widgets_avec_valeur_defaut($arg=''){
    include_spip('inc/ciwidget_commun');    
    $return = array();
    $types_widget = ciwidget_types_widget();

    foreach ($types_widget AS $cle=>$type_widget) {
        if (isset($type_widget['id']) AND isset($type_widget['valeurs_par_defaut'])){
            $return[$type_widget['id']] = $type_widget['id'];
        }
    };
    
    return $return;
}

function ciwidget_tableau_des_elements_par_widget($arg=''){
    include_spip('inc/ciwidget_commun');
    $return = array();
    $types_widget = ciwidget_types_widget();

    foreach ($types_widget AS $cle=>$type_widget) {
        if (isset($type_widget['id']) AND isset($type_widget['elements'])){
            $return[$type_widget['id']] = explode(',',$type_widget['elements']);
        }
    };
    
    return $return;
}

function ciwidget_tableau_des_elements_du_widget($widget=''){
    include_spip('inc/ciwidget_commun');
    $return = array();
    $types_widget = ciwidget_types_widget();

    foreach ($types_widget AS $cle=>$type_widget) {
        if (isset($type_widget['id']) AND $type_widget['id']==$widget AND isset($type_widget['elements'])){
            $return = explode(',',$type_widget['elements']);
        }
    };
    
    return $return;
}

function ciwidget_tableau_id_widgets_avec_css($arg=''){
    include_spip('inc/ciwidget_commun');    
    $return = array();
    $types_widget = ciwidget_types_widget();
    $exceptions = array('graphique');

    foreach ($types_widget AS $cle=>$type_widget) {
        if (isset($type_widget['id']) AND !in_array($type_widget['id'],$exceptions) AND isset($type_widget['css']) AND $type_widget['css']=='oui'){
            $return[$type_widget['id']] = $type_widget['id'];
        }
    };
    
    return $return;
}

function ciwidget_config_cle($type_widget='',$cle=''){
    $return = '';
    
    if ($type_widget AND $cle){
        include_spip('inc/widget_commun');
        include_spip('inc/ciwidget_inc_meta');
        
        $return = ciwidget_lire_meta_cle($type_widget,$cle);
    }
    
    return $return;
}

function ciwidget_desactiver($type_widget=''){
    $return = false;
    $ci_statut = ciwidget_config_cle($type_widget,'statut');

    if ($type_widget AND $ci_statut AND $ci_statut=='desactive'){
          $return = true;
          
    } elseif (defined('_CIWIDGET_DESACTIVE_TOUS_WIDGETS_RGPD') AND _CIWIDGET_DESACTIVE_TOUS_WIDGETS_RGPD=='oui'){
        // desactivation forcée par constante des widgets concernés par le RGPD
        include_spip('inc/ciwidget_commun');
        $types_widget = ciwidget_types_widget();

        foreach ($types_widget AS $cle=>$valeur) {
            if (isset($valeur['id']) AND $valeur['id']==$type_widget){ 
                if (isset($valeur['concerne_rgpd']) AND $valeur['concerne_rgpd']=='oui'){
                    $return = true;
                }
                break;
            }
        }
    }
    
    return $return;
}

function ciwidget_align_widget($type_widget='',$align_user=''){
    $return = '';
    $align = '';
    
    $config_align = ciwidget_config_cle($type_widget,'imposer_alignement_widget');
    
    if ($config_align AND in_array($config_align,array('left','center','right'))){
        $align = $config_align;
    } elseif ($align_user AND in_array($align_user,array('left','center','right'))){ 
        $align = $align_user;
    }
    
    if ($align=='center'){
        $return = "margin-left:auto;margin-right:auto;";
    } elseif ($align=='right'){
        $return = "margin-left:auto;";
    }
    
    return $return;
}


/**
 * Balise `#CIWIDGET_VERSION_TEXTE_DEBUT`
 * @example d'utilisation
 *   ```
 *   [ [(#CIWIDGET_VERSION_TEXTE_DEBUT{#ID_DOCUMENT})]
 *   (#DESCRIPTIF)
 *   [(#CIWIDGET_VERSION_TEXTE_FIN)] ]
 * 
 * @autre example d'utilisation
 *   ```
 *   [ [(#CIWIDGET_VERSION_TEXTE_DEBUT{#ID_WIDGET})]
 *   (#DESCRIPTIF)
 *   [(#CIWIDGET_VERSION_TEXTE_FIN)] ]
 */
function balise_CIWIDGET_VERSION_TEXTE_DEBUT_dist($p) {
	$_id = interprete_argument_balise(1, $p);
       	$_titre = interprete_argument_balise(2, $p);
       	$_type_widget = interprete_argument_balise(3, $p);
	if (empty($_id)) {
		$_id = "''";
	}
	if (empty($_titre)) {
		$_titre = "''";
	}
	if (empty($_type_widget)) {
		$_type_widget = "''";
	}

	$f = chercher_filtre('ciwidget_version_texte_debut');
	$p->code = "$f($_id, $_titre, $_type_widget)";
	$p->interdire_scripts = false;

	return $p;
}


/**
 * Balise `#CIWIDGET_VERSION_TEXTE_FIN`
 */
function balise_CIWIDGET_VERSION_TEXTE_FIN_dist($p) {
	$f = chercher_filtre('ciwidget_version_texte_fin');
	$p->code = "$f()";
	$p->interdire_scripts = false;

	return $p;
}

/**
 * ciwidget_version_texte_debut
 * Peut être surchargé par `filtre_ciwidget_version_texte_debut_dist` ou `filtre_ciwidget_version_texte_debut`
 */
function ciwidget_version_texte_debut($id = '', $titre = '', $type_widget = '') {
        if ($titre){
            $titre = attribut_html($titre);
        }  else {
            $titre = "widget ".$id;
        }
        
        return '<div class="ciwidget_bouton_version_texte_wrap bouton_version_texte_wrap">'  
        . '<button class="bouton_version_texte" title="'.$titre.'" aria-expanded="false" aria-controls="version_texte_'.$id.'" data-hide="'._T('ciwidget:voir_version_texte').'" data-show="'._T('ciwidget:masquer_version_texte').'">'._T('ciwidget:voir_version_texte').'</button>'
        . '</div>'
        . '<div id="version_texte_'.$id.'" class="version_texte">';
}

/**
 * ciwidget_version_texte_fin
 * Peut être surchargé par `filtre_ciwidget_version_texte_fin_dist` ou `filtre_ciwidget_version_texte_fin`
 */
function ciwidget_version_texte_fin() {
	return '</div>';
}

function filtre_ciwidget_modele_document_standard_classes_dist($Pile, $id_document, $media) {
	$classes = array();

	$classes[] = "spip_document_$id_document";
        $env = $Pile[0];
        
	if (spip_version()>=4) {
            $classes[] = 'spip_document';
            $classes[] = 'spip_documents';
            if ($media === 'infographie'){
                $media = 'image';
                $classes[] = 'ciwidget_display_inherit';
                $classes[] = 'ciwidget_infographie';
            }
            if (!empty($env['align'])) {
                    $classes[] = 'ciwidget_' . $env['align'];
            } elseif ($media === 'image') {
                    $classes[] = 'ciwidget_center';
            }
        } else {    
            if ($media === 'infographie'){
                $media = 'image';
                $classes[] = 'ciwidget_infographie';
            }
        }
  
	return implode(" ", $classes);
}

function ciwidget_config_imposee($type='') {
    $return = '';

    include_spip('inc/ciwidget_inc_meta');
    
    if ($type=='couleur'){
        if (ciwidget_parametrage_couleur_par_fichier()){
                $return = _T('ciwidget:config_imposee');
        }
    } elseif ($type=='rgpd'){
        if (ciwidget_parametrage_rgpd_par_fichier()){
                $return = _T('ciwidget:config_imposee');
        }
    } else {
        if (ciwidget_parametrage_widget_par_fichier($type)){
                $return = _T('ciwidget:config_imposee');
        }
    }    
        
    return $return;
}

function ciwidget_diviser($a, $b) {
    $a = intval($a);
    $b = intval($b);
    return $b ? $a / $b : 0;
}

function ciwidget_diviser_float($a, $b) {
    $a = floatval($a);
    $b = floatval($b);
    return $b ? $a / $b : 0;
}

function ciwidget_texte_sans_paragraphe($texte){
    return str_replace(array('<p>','</p>'),array('',''),$texte);
}

function ciwidget_style_zoom($type_widget='',$element='',$zoom=100){
    $return = '';
    $propriete = 'font-size';
    $propriete2 = 'line-height';
    
    if ($type_widget AND $element AND $zoom AND intval($zoom)>0 AND $zoom!="100"){
        include_spip('inc/ciwidget_inc_style');
        $tableau_style = ciwidget_tableau_style_element($type_widget,$element);

        if (isset($tableau_style[$propriete]) AND $valeur=$tableau_style[$propriete]){
            $zoom = intval($zoom)/100;
            $size = floatval($valeur);
            $unite = str_replace($size,'',$valeur);
            $fontsize = strval($size*$zoom).$unite;

            if (isset($tableau_style[$propriete2]) AND $valeur2=$tableau_style[$propriete2]){
                $size = floatval($valeur2);
                $unite = str_replace($size,'',$valeur2);
                $lineheight = strval($size*$zoom).$unite;
            } else {
                $lineheight = $fontsize;
            }

            $return = 'style="font-size:'.$fontsize.';line-height:'.$lineheight.';"';
        }
    }
    
    return $return;
}

function ciwidget_liste_config_widget($widget=''){
    include_spip('inc/ciwidget_inc_meta');
    
    $return = '';
    
    $tableau_des_elements = ciwidget_tableau_des_elements_du_widget($widget);

    $prefixe_titre = _T('ciwidget:style');
    $lib_bouton = _T('bouton_modifier');
    $config_imposee = ciwidget_config_imposee($widget);
    if ($config_imposee){
        $html_config_imposee = '<span class="ciwidget_config_imposee">'.$config_imposee.'</span>';
    } else {
        $html_config_imposee = '';
    }
    
    foreach ($tableau_des_elements AS $element){
        $return .= PHP_EOL.'<div class="formulaire_spip ciwidget_lister_config">';
        $return .= PHP_EOL.'<h3 class="titrem">'.$prefixe_titre.' '._T('ciwidget:'.$widget.'_'.$element).$html_config_imposee.'</h3>';
        $return .= PHP_EOL.'<p>'.ciwidget_liste_style_element($widget,$element).'</p>';    
        if (!$config_imposee){
            $return .= PHP_EOL.'<p class="boutons"><a href="'.generer_url_ecrire('ciwidget_config_style','widget='.$widget.'&element='.$element.'&retour=ciwidget_lister_config_'.$widget).'" class="btn" role="button">'.$lib_bouton.'</a></p>';
        }
        $return .= PHP_EOL.'</div>'.PHP_EOL;
    }

    return $return;
}

?>