<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');
include_spip('inc/video_commun');
include_spip('inc/doc_commun');
include_spip('formulaires/joindre_document');
include_spip('inc/documents');


function formulaires_ciwidget_audio_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
	if (!autoriser('modifier',$objet,$id_objet)){
		return false;
        }
        
        $type_widget = 'audio';
        $valeurs = ciwidget_document_charger($objet, $id_objet, $type_widget, $id_widget, $retour);
        $valeurs['retour_objet'] = ciwidget_retour_vers_objet($objet, $id_objet);
        
        if (ciwidget_utiliser_bigup()) {
          $valeurs['_bigup_rechercher_fichiers'] = true;
        }
      
        return $valeurs;
}

function formulaires_ciwidget_audio_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
    $erreurs = array();
    $erreurs_upload = array();
    $id_widget = intval($id_widget);
    $type_format = 'audio';
        
    if ($objet AND $id_objet){
        
        if ($id_widget){
    
            $titre = _request('titre');	
            if (!$titre){
                    $erreurs['titre'] = _T('info_obligatoire');
            }

            if (_request('duree_editable')=='oui' AND ciwidget_erreur_duree(_request('duree'))){
                $erreurs['duree'] = ciwidget_erreur_duree(_request('duree'));
            }	
        
        }
        
        if (_request('joindre_upload')) {
            $verifier = charger_fonction('verifier', 'formulaires/joindre_document');
            if ($id_widget){
                   // verifier l'upload si on a demande a changer le document
                if ($contenu_actuel = sql_getfetsel("contenu", "spip_ciwidget", "id_widget=$id_widget")){
                    $contenu_actuel_unserialize = unserialize($contenu_actuel);
                    if (isset($contenu_actuel_unserialize['id_document'])){
                        $id_document = intval($contenu_actuel_unserialize['id_document']);
                        $erreurs_upload = $verifier($id_document);
                    }
                }
            } else {
                $erreurs_upload = $verifier('new', $id_objet, $objet);
            }
            
            if (!$erreurs_upload) {
                $post = isset($_FILES) ? $_FILES : $GLOBALS['HTTP_POST_FILES'];
                $erreur_format = ciwidget_verifier_upload_formats_autorises($post,$type_format);
                if ($erreur_format){
                    $erreurs['fichier_upload'] = $erreur_format;
                }
            } else {
                $erreurs = array_merge($erreurs, $erreurs_upload);
            }
            
        } elseif (_request('joindre_distant')) {
            $path = _request('url');
            if ($path){
                $extension = ciwidget_extension_fichier_distant($path);
                $erreur_format = ciwidget_verifier_distant_formats_autorises($path,$extension,$type_format);
                if ($erreur_format){
                    $erreurs['url'] = $erreur_format;
                }
            }
        }
    }
        
    return $erreurs;
}

function formulaires_ciwidget_audio_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $type_widget = 'audio';
        
        return ciwidget_document_traiter($objet, $id_objet, $type_widget, $id_widget, $retour);
}

?>