<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');

function formulaires_ciwidget_illustrer_widget_charger_dist($id_widget=0,$libelle_vignette='') {
	include_spip('inc/documents');
        $valeurs = array();
        $vignette = array();

        $valeurs = sql_fetsel('id_document', 'spip_documents_liens', "objet='ciwidget' AND id_objet=" . intval($id_widget));
        
        if ($valeurs){
                $vignette = sql_fetsel('fichier,largeur,hauteur,id_document', 'spip_documents', 'id_document=' . intval($valeurs['id_document']));
        }        
        
        $valeurs['id'] = $id_widget;
        $valeurs['_hidden'] = "<input name='id_widget' value='$id_widget' type='hidden' />";
    //	$valeurs['mode'] = 'vignette'; // pour les id dans le dom

        if ($vignette) {
                $valeurs['vignette'] = get_spip_doc($vignette['fichier']);
                $valeurs['hauteur'] = $vignette['hauteur'];
                $valeurs['largeur'] = $vignette['largeur'];
                $valeurs['id_vignette'] = $vignette['id_document'];
        } else {
                $valeurs['vignette'] = null;
                $valeurs['hauteur'] = null;
                $valeurs['largeur'] = null;
                $valeurs['id_vignette'] = null;
        }
        
        $valeurs['libelle_vignette'] = $libelle_vignette;
        
        if (ciwidget_utiliser_bigup()) {
          $valeurs['_bigup_rechercher_fichiers'] = true;
        }
        
	return $valeurs;
}

function formulaires_ciwidget_illustrer_widget_verifier_dist($id_widget=0,$libelle_vignette='') {
	$erreurs = array();

        if (_request('supprimer')) {
        } else {
                $id_vignette = sql_getfetsel('id_document', 'spip_documents_liens', "objet='ciwidget' AND id_objet=" . intval($id_widget));
                $verifier = charger_fonction('verifier', 'formulaires/joindre_document');
                $erreurs = $verifier($id_vignette, $id_widget, 'ciwidget');
        }
        
	return $erreurs;
}

function formulaires_ciwidget_illustrer_widget_traiter_dist($id_widget=0,$libelle_vignette='') {
	$res = array('editable' => true);
        
	$id_document = sql_getfetsel('id_document', 'spip_documents_liens', "objet='ciwidget' AND id_objet=" . intval($id_widget));
  $id_document = intval($id_document);
        
	if (_request('supprimer')) {
              	include_spip('inc/documents');
      					if ($ancien_fichier = sql_getfetsel('fichier','spip_documents','id_document='.$id_document)) {
      						$f = get_spip_doc($ancien_fichier);
      					  	if (@file_exists($f)) {
        							spip_unlink($f);
      					  	}
      					}
                sql_delete('spip_documents_liens', "id_document=".$id_document." AND objet='ciwidget' AND id_objet=".$id_widget);
                $res['message_ok'] = _T('medias:vignette_supprimee');
                
	} else {
		$ajouter_documents = charger_fonction('ajouter_documents', 'action');

		include_spip('inc/joindre_document');
		$files = joindre_trouver_fichier_envoye();

		$ajoute = $ajouter_documents($id_document, $files, 'ciwidget', $id_widget, 'image');

		if (is_numeric(reset($ajoute))
			and $id_document = reset($ajoute)
		) {
//			include_spip('action/editer_document');
//			document_modifier($id_document, array('id_vignette' => $id_document, 'mode' => 'document'));
			$res['message_ok'] = _T('medias:document_installe_succes');
		} else {
			$res['message_erreur'] = reset($ajoute);
		}
	}

	// todo :
	// generer les case docs si c'est necessaire
	// rediriger sinon
	return $res;
}
