<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');

function formulaires_ciwidget_slideshare_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
	if (!autoriser('modifier',$objet,$id_objet))
		return false;

        $valeurs = array('titre'=>'','descriptif'=>'','credits'=>'','url'=>'','largeur'=>'595');
        
        $id_widget = intval($id_widget);
	if ($id_widget>0) {
		$result = sql_select("*", "spip_ciwidget", "id_widget=$id_widget");
		while ($row = sql_fetch($result)) { 
			$valeurs = $row;
		}
        
                // anti hack
                if (isset($valeurs['type_widget']) AND $valeurs['type_widget']!='slideshare'){
                    return false;
                }
                
                // unserialize le champ contenu
                if (isset($valeurs['contenu'])){
                    $contenu = unserialize($valeurs['contenu']);
                    $valeurs['contenu'] = '';
                    if ($contenu AND is_array($contenu)){
                        $valeurs = array_merge($valeurs,$contenu);
                    }
                }
	}

        if (ciwidget_lire_meta_cle('slideshare','largeur_non_modifiable')=='oui'){
            $valeurs['ci_largeur_non_modifiable'] = 'oui';
            $valeurs['largeur'] = ciwidget_lire_meta_cle('slideshare','largeur_defaut');
        }
        
        $valeurs['retour_objet'] = ciwidget_retour_vers_objet($objet, $id_objet);

	return $valeurs;
}

function formulaires_ciwidget_slideshare_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $erreurs = array();
        
	$titre = _request('titre');	
	if (!$titre){
		$erreurs['titre'] = _T('info_obligatoire');
        }
        
	$url = _request('url');	
	if (!$url){
		$erreurs['url'] = _T('info_obligatoire');
        } elseif (!ci_slideshare_id($url)) {
		$erreurs['url'] = _T('ciwidget:valeur_incorrecte');
        }
        
	if (ciwidget_erreur_largeur(_request('largeur'))){
            $erreurs['largeur'] = ciwidget_erreur_largeur(_request('largeur'));
        }
        
	return $erreurs;
}

function formulaires_ciwidget_slideshare_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $id_widget = intval($id_widget);

        $c = array();
	foreach (array('titre', 'descriptif') as $champ){
		$c[$champ] = _request($champ);
        }
        
        $url = _request('url');
        $largeur = ciwidget_verif_largeur_sinon_defaut(_request('largeur'), 595);
	$ratio = _request('ratio');
        if (!$ratio OR $ratio!='16_9'){
            $ratio = '4_3';
        }
        $credits = _request('credits');
        
        $type_widget = 'slideshare';
        $c['contenu'] = serialize(array('url'=>$url, 'largeur'=>$largeur, 'ratio'=>$ratio, 'credits'=>$credits));
        $c['type_widget'] = $type_widget;
        $c['objet'] = $objet;
        $c['id_objet'] = $id_objet;

	if ($id_widget>0) {
            // modifier
            sql_updateq("spip_ciwidget", $c, "id_widget=$id_widget");
        } else {
            // ajouter et lier
            $id_widget = sql_insertq('spip_ciwidget', $c);
        }
    
        $res = ciwidget_retour_formulaire($objet,$id_objet,$type_widget,$retour);

	return $res;
}

function ci_slideshare_id($url){
    $return = '';
 
    if (empty($url)){
        return $return;
    }
    
    $url = str_replace('&#038;','&',$url);
    $url = str_replace('&amp;','&',$url);
    
    $tableau = explode('&',$url);
    if (isset($tableau[0])){
        $tableau2 = explode('=',$tableau[0]);
        if (isset($tableau2[1]) AND intval($tableau2[1])>0){
            $return = intval($tableau2[1]);
        }
    }
    
    return $return;
}

?>