<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');
include_spip('inc/ciwidget_tmp');
include_spip('inc/ciwidget_graphique');
include_spip('inc/ciwidget_importer');
include_spip('inc/texte');
include_spip('inc/filtres_boites');

function formulaires_ciwidget_tableau_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
    
        if (!$id_widget AND !$id_widget_tmp AND !autoriser('modifier',$objet,$id_objet)){
		return false;
        }
    
        // verifier si les donnees temporaires existent deja pour ce widget (quelque soit l'auteur)
        $modif_en_cours = '';
        $date_creation_tmp_existant = '';
        $id_auteur_tmp_existant = '';
        if ($id_widget AND !$id_widget_tmp){
            $result = sql_select("date_creation_tmp,id_auteur", "spip_ciwidget_tmp", "id_widget=".intval($id_widget),"","date_creation_tmp");
            while ($row = sql_fetch($result)) { 
                    $date_creation_tmp_existant = $row['date_creation_tmp'];
                    $id_auteur_existant = $row['id_auteur'];
            }
        }
        
        // mode creation
        if (!$id_widget AND !$id_widget_tmp){
            
            if (!$objet OR !$id_objet){
                    return false;
            }
            
            $c = array();
            $c['type_widget'] = 'tableau';
            $c['objet'] = $objet;
            $c['id_objet'] = $id_objet;
            $c['id_auteur'] = intval($GLOBALS['visiteur_session']['id_auteur']);
        
            $id_widget_tmp = ciwidget_maj_tmp($id_widget,$id_widget_tmp,$c);
        }
        
        $valeurs = ciwidget_valeurs_tmp($id_widget,$id_widget_tmp,'tableau');

        if ($id_widget AND !$id_widget_tmp AND isset($valeurs['id_widget_tmp'])){
            $id_widget_tmp = $valeurs['id_widget_tmp'];
        }
        
        // securite
        if (intval($id_widget_tmp) > 0){
            if (!isset($valeurs['objet']) OR !isset($valeurs['id_objet']) OR !isset($valeurs['id_auteur']) 
                    OR !autoriser('modifier',$valeurs['objet'],$valeurs['id_objet'])
                    OR $valeurs['id_auteur']!=$GLOBALS['visiteur_session']['id_auteur']){
                    return false;
            }
        }
        
        $contenus = ciwidget_tableau_champs();
        foreach ($contenus AS $contenu=>$defaut){
            if (!isset($valeurs[$contenu]) OR !$valeurs[$contenu]){
                $valeurs[$contenu] = $defaut;
            }
        }
        
        $valeurs['retour_objet'] = ciwidget_retour_tmp_vers_objet($id_widget_tmp,$objet,$id_objet,$valeurs);
        
        // verifier si le contenu permanent a ete modifie depuis sa creation
        $acces_concurrent = '';
        if ($id_widget AND $id_widget_tmp){

            // verifier si les donnees permanentes ont ete modifiees entre temps (acces concurrent)
            $maj_initiale = '';
            if (isset($valeurs['maj'])){
                $maj_initiale = $valeurs['maj'];
            }
            $maj_actuelle = sql_getfetsel("maj", "spip_ciwidget", "id_widget=".$id_widget);
            if ($maj_initiale!=$maj_actuelle){
                $acces_concurrent = 'oui';
            }
        }
        
        // signaler en cours d'edition le cas echeant
        $modif_en_cours = '';
        if ($id_widget AND $date_creation_tmp_existant AND $id_auteur_existant AND isset($valeurs['maj'])){
            if (strtotime($date_creation_tmp_existant) >= strtotime($valeurs['maj'])
                AND time() < (86400 + strtotime($date_creation_tmp_existant)) ){
                $nom_auteur_tmp_existant = sql_getfetsel('nom', 'spip_auteurs', 'id_auteur='.intval($id_auteur_existant));

		// format lie a la chaine de langue
		$tableau_modif_en_cours = array(
			'nom_auteur_modif' => $nom_auteur_tmp_existant,
			'date_diff' => ceil((time() - strtotime($date_creation_tmp_existant)) / 60)
		);
                if (intval($id_auteur_existant) == intval($GLOBALS['visiteur_session']['id_auteur'])){
                    // sauf si F5
                    if (isset($_SERVER['HTTP_REFERER'])){
//                        $modif_en_cours = _T('ciwidget:info_meme_auteur_edite', $tableau_modif_en_cours);
                    }
                } else {
                    $modif_en_cours = _T('ciwidget:info_autre_auteur_edite', $tableau_modif_en_cours);                
                }    
            }
        }
        
        $valeurs['modif_en_cours'] = $modif_en_cours;            
        $valeurs['acces_concurrent'] = $acces_concurrent;            
        
	return $valeurs;
}

function formulaires_ciwidget_tableau_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
        $erreurs = array();

        if (_request('reset')) {
            return $erreurs;
        }
        
	$titre = _request('titre');	
	if (!$titre){
            $erreurs['titre'] = _T('info_obligatoire');
        } else {
            $data = ciwidget_graphique_extraire_data(_request('donnees'));
            if (substr($data,0,11)=='[["","","",' OR substr($data,0,11)=="[['','','',"){
                $erreurs['donnees'] = _T('info_obligatoire');
            }
        }

        // verifier si le contenu permanent a ete modifie depuis sa creation
        if (!$id_widget){
            $id_widget = _request('id_widget');
        }
        if (!$id_widget_tmp){
            $id_widget_tmp = _request('id_widget_tmp');
        }
        
        $acces_concurrent = '';
        if ($id_widget AND $id_widget_tmp){

            // verifier si les donnees permanentes ont ete modifiees entre temps (acces concurrent)
            $maj_initiale = sql_getfetsel("maj", "spip_ciwidget_tmp", "id_widget_tmp=".$id_widget_tmp);
            $maj_actuelle = sql_getfetsel("maj", "spip_ciwidget", "id_widget=".$id_widget);
            if ($maj_initiale!=$maj_actuelle){
                $erreurs['donnees'] = _T('ciwidget:acces_concurent');
            }
        }
        
	return $erreurs;
}

function formulaires_ciwidget_tableau_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
        refuser_traiter_formulaire_ajax();    
    
        $type_widget = 'tableau';
        $res = array();
        $c = array();

        if (_request('reset')) {
            if (!$id_widget_tmp){
                $id_widget_tmp = _request('id_widget_tmp');
            }
            if ($id_widget_tmp){
                sql_updateq("spip_ciwidget_tmp", array('date_creation_tmp'=>'0000-00-00 00:00:00'), "id_widget_tmp=$id_widget_tmp");
                $res['message_ok'] = 'Ok';
                $res['redirect'] = ciwidget_retour_tmp_vers_objet($id_widget_tmp);
            }
            
        } else {

            // mode creation
            if (!$objet){
                $objet = _request('objet');
            }
            if (!$id_objet){
                $id_objet = _request('id_objet');
            }
            if (!$id_widget){
                $id_widget = _request('id_widget');
            }
            if (!$id_widget_tmp){
                $id_widget_tmp = _request('id_widget_tmp');
            }

            // mode creation ou modification
            $c['type_widget'] = $type_widget;
            if ($objet){
                $c['objet'] = $objet;
            }
            if ($id_objet){
                $c['id_objet'] = $id_objet;
            }
            if ($id_widget){
                $c['id_widget'] = $id_widget;
            }
            if (!$id_widget_tmp){
                $c['id_auteur'] = intval($GLOBALS['visiteur_session']['id_auteur']);
            }

            $c['titre'] = _request('titre');
            $c['descriptif'] = _request('descriptif');
            $c['donnees'] = ciwidget_graphique_extraire_data(_request('donnees'));

            $contenu_nouveau = array();
            $contenus = ciwidget_tableau_champs();
            foreach ($contenus AS $contenu=>$defaut){
                $contenu_nouveau[$contenu] = _request($contenu);
                if (!isset($contenu_nouveau[$contenu]) OR $contenu_nouveau[$contenu]==NULL){
                    $contenu_nouveau[$contenu] = 'non';
                }
            }

            $contenu_nouveau['colonnes'] = ciwidget_graphique_extraire_colonnes(_request('donnees'));

            // memoriser la conversion en HTML (SPIP) du tableau
            $c['cache'] = ciwidget_convertir_tableau_en_html($c['donnees'],$c['titre'],$c['descriptif'],$contenu_nouveau['entete_colonne'],$contenu_nouveau['entete_ligne'],$id_widget_tmp);

            $id_widget_tmp = ciwidget_maj_tmp($id_widget,$id_widget_tmp,$c,$contenu_nouveau);
        
            $res['message_ok'] = 'Ok';
            $res['redirect'] = ciwidget_retour_tmp_vers_objet($id_widget_tmp);

            // A mettre imperativement a la fin
            // Verser les donnees temporaires dans les donnees persistantes
            $id_widget = ciwidget_verser_tmp_dans_widget($id_widget_tmp,$type_widget);
            
        }
        
	return $res;
}

function ciwidget_tableau_champs(){
    return array(
        'entete_colonne'=>'oui',
        'entete_ligne'=>'non'
        );
}

function ciwidget_tableau_tmp_tableau($id_widget_tmp){
    return ciwidget_tableau_tableau_json_optimise($id_widget_tmp,false,true,false);
}

function ciwidget_tableau_tableau_json_optimise($id_widget=0,$mettre_en_colonne=true,$tmp=false,$optimise=true){
    $return = '';
    $donnees_vide = false;
    
    $id_widget = intval($id_widget);
    if ($id_widget>0){
        $data = '';

        if ($tmp){
            $valeurs = ciwidget_valeurs_tmp(0,$id_widget,'tableau');
        } else {
            $valeurs = ciwidget_valeurs_lues_en_base($id_widget,'tableau');
        }

        if (isset($valeurs['donnees']) AND $valeurs['donnees']){
            $data = $valeurs['donnees'];
            
        } else {
            if ($tmp AND _request('donnees')){
                $data = ciwidget_graphique_extraire_data(_request('donnees'));
            } else {
                $donnees_vide = true;
            }
        }

        if (!$donnees_vide){
            if ($optimise){
                $return = ciwidget_optimise_donnees_json($data);
            } else {
                $return = $data;
            }    
        } else {
            $return = "[]";
        }
    }
    
    return $return;
}

function ciwidget_tableau_colonnes($id_widget_tmp){
        $colonnes = '';
        $id_widget = 0;
        $valeurs = ciwidget_valeurs_tmp($id_widget,$id_widget_tmp,'tableau');
        
        if (isset($valeurs['colonnes']) AND $valeurs['colonnes']){
            $colonnes = $valeurs['colonnes'];
            
            // enlever les "name" car dans certains cas cela gêne jexcel
            $pattern = '/"name":"\d+"/i';
            $colonnes = preg_replace($pattern, '', $colonnes);  
            $pattern = '/"name":\d+/i';
            $colonnes = preg_replace($pattern, '', $colonnes);  
            
            $colonnes = str_replace('"align":"center"', ',', $colonnes);            
            $colonnes = str_replace(array(',,,',',,',',}'), array(',',',','}'), $colonnes);            
        }
        
        if (!$colonnes){
            if (_request('donnees')){
                $colonnes = ciwidget_graphique_extraire_colonnes(_request('donnees'));
            } else {
                for ($i = 0; $i < 4; $i++){
                    $colonnes .= "{type:'text'},";
                }
                $colonnes = "[".substr($colonnes,0,-1)."]";
            }
        }
        
        return $colonnes;
}

function ciwidget_convertir_tableau_en_html($donnees='',$titre='',$descriptif='',$entete_colonne='non',$entete_ligne='non',$id_widget_tmp=0,$id_widget=0){
    $return = '';
    
    $tableau_json = ciwidget_optimise_donnees_json($donnees);

    return ciwidget_tableau_traiter_tableau($id_widget,$id_widget_tmp,$tableau_json,$titre,$descriptif,$entete_colonne,$entete_ligne);
}

/**
 * Traitement des raccourcis de tableaux
 *
 * @param string $bloc
 * @return string
 */
function ciwidget_tableau_traiter_tableau($id_widget=0,$id_widget_tmp=0,$tableau_json='',$titre='',$descriptif='',$entete_colonne='non',$entete_ligne='non') {

        // id "unique" pour les id du tableau
        if (intval($id_widget)>0){
            $tabid = substr(md5($id_widget."widget"), 0, 4);
        } elseif (intval($id_widget_tmp)>0){
            $tabid = substr(md5($id_widget_tmp."tmp_widget"), 0, 4);
        } else {
            $tabid = substr(md5($tableau_json), 0, 4);
        }
        $tableau_php = json_decode($tableau_json, true);
        
	$lignes = array();
	$debut_table = '';
        $caption = '';
        $summary = '';
        $iddescribedby = '';
	$l = 0;
	$numeric = true;
	$hc = $hl = array();

        
        // <caption> et summary
        // summary est deprecated en HTML5 => alignement sur SPIP 3.3
        if ($descriptif) {
            $iddescribedby = 'dby'.$tabid;
            $summary = ' aria-describedby="'.$iddescribedby.'"';
        }
        if ($titre) {
            $caption = interdire_scripts(propre($titre));
            // pas de paragraphe pour le titre
            if (substr($caption,0,3)=='<p>' AND substr($caption,-4)=='</p>'){
                $caption = substr($caption,3,-4);
            }
            if ($descriptif) {
                    $caption .= '<small id="'.$iddescribedby.'" class="summary offscreen ciwidget_offscreen">' . entites_html(trim($descriptif)) . '</small>';
            }
            $debut_table .= "<caption>" . $caption . "</caption>\n";
        } elseif ($descriptif) {
            $debut_table .= '<caption id="'.$iddescribedby.'" class="summary offscreen ciwidget_offscreen"><small>' . entites_html(trim($descriptif)) . "</small></caption>\n";
        }
        
	foreach ($tableau_php as $row) {
		$l++;

		// Gestion de la premiere ligne :
		if ($l == 1 AND $entete_colonne=='oui') {
			//   Attention thead oblige a avoir tbody
                        $ligne = '';
                        $cols = $row;
                        $colspan = 1;
                        for ($c = count($cols) - 1; $c >= 0; $c--) {
                                $attr = '';
                                if ($cols[$c] == '<') {
                                        $colspan++;
                                } else {
                                        if ($colspan > 1) {
                                                $attr = " colspan='$colspan'";
                                                $colspan = 1;
                                        }
                                        // inutile de garder le strong qui n'a servi que de marqueur
                                        $cols[$c] = str_replace(array('{', '}'), '', $cols[$c]);
                                        $ligne = "<th id='id{$tabid}_c$c'$attr>".interdire_scripts(propre($cols[$c]))."</th>$ligne";
                                        $hc[$c] = "id{$tabid}_c$c"; // pour mettre dans les headers des td
                                }
                        }

                        $debut_table .= "<thead><tr class='row_first'>" .
                                $ligne . "</tr></thead>\n";

		// Sinon ligne normale
                } else {
			$cols = $row;

			foreach ($cols as &$col) {
                            if (strlen($col = trim($col))) {
                                $pos = strpos($col, "\n");
                                if ($pos !== false) {
                                    // Gerer les listes a puce dans les cellules
                                    // on declenche simplement sur \n- car il y a les
                                    // -* -# -? -! (qui produisent des -&nbsp;!)
                                    if (strpos($col, "\n-") !== false) {
                                            $col = traiter_listes($col);
                                            
                                            // traiter_listes ajoute un \n au debut
                                            // qu'il convient de retirer
                                            if ($pos>0  AND strpos($col, "\n")===0){
                                                $col = substr($col,1);
                                            }
                                    }

                                    // Pas de paragraphes dans les cellules
                                    $col = preg_replace("/\n{2,}/S", "<br /> <br />", $col);
                                    if (_AUTOBR) {
                                            $col = str_replace("\n", _AUTOBR . "\n", $col);
                                    }
                                }
                            }
			}

			// assembler le tableau
			$lignes[] = $cols;
		}
	}


        
	// maintenant qu'on a toutes les cellules
	// on prepare une liste de rowspan par defaut, a partir
	// du nombre de colonnes dans la premiere ligne.
	// Reperer egalement les colonnes numeriques pour les cadrer a droite
	$rowspans = array();
	$numeric = array();
	$n = count($lignes[0]);
	$k = count($lignes);
	// distinguer les colonnes numeriques a point ou a virgule,
	// pour les alignements eventuels sur "," ou "."
	$numeric_class = array(
		'.' => 'point',
		',' => 'virgule',
		true => ''
	);
	for ($i = 0; $i < $n; $i++) {
		$align = true;
		for ($j = 0; $j < $k; $j++) {
			$rowspans[$j][$i] = 1;
			if ($align and preg_match('/^[{+-]*(?:\s|\d)*([.,]?)\d*[}]*$/', trim($lignes[$j][$i]), $r)) {
				if ($r[1]) {
					$align = $r[1];
				}
			} else {
				$align = '';
			}
		}
		$numeric[$i] = $align ? (" class='numeric " . $numeric_class[$align] . "'") : '';
	}
        if ($entete_ligne=='oui'){
            for ($j = 0; $j < $k; $j++) {
                $hl[$j] = "id{$tabid}_l$j"; // pour mettre dans les headers des td
            }
        } else {
		$hl = array();
	} // toute la colonne ou rien

	// et on parcourt le tableau a l'envers pour ramasser les
	// colspan et rowspan en passant
	$html = '';

	for ($l = count($lignes) - 1; $l >= 0; $l--) {
		$cols = $lignes[$l];
		$colspan = 1;
		$ligne = '';

		for ($c = count($cols) - 1; $c >= 0; $c--) {
			$attr = $numeric[$c];
			$cell = trim($cols[$c]);
			if ($cell == '<') {
				$colspan++;

			} elseif ($cell == '^') {
				$rowspans[$l - 1][$c] += $rowspans[$l][$c];

			} else {
				if ($colspan > 1) {
					$attr .= " colspan='$colspan'";
					$colspan = 1;
				}
				if (($x = $rowspans[$l][$c]) > 1) {
					$attr .= " rowspan='$x'";
				}
				$b = ($c == 0 and isset($hl[$l])) ? 'th' : 'td';
				$h = (isset($hc[$c]) ? $hc[$c] : '') . ' ' . (($b == 'td' and isset($hl[$l])) ? $hl[$l] : '');
				if ($h = trim($h)) {
					$attr .= " headers='$h'";
				}
				// inutile de garder le strong qui n'a servi que de marqueur
				if ($b == 'th') {
					$attr .= " id='" . $hl[$l] . "'";
					$cols[$c] = str_replace(array('{', '}'), '', $cols[$c]);
				}
                                // appliquer la fonction propre
                                // en protegeant le signe - en début de cellule (via trim)
                                // (sinon SPIP les transforme en puce)
                                $ci_pos_moins = false;
                                $ci_pos_moins_trim = strpos(trim($cols[$c]),"-");
                                if ($ci_pos_moins_trim!==false AND $ci_pos_moins_trim<1){
                                    $ci_pos_moins = strpos($cols[$c],"-");
                                }
                                if ($ci_pos_moins!==false){
                                    $ci_propre = substr_replace($cols[$c],"&ndash;",$ci_pos_moins,1);
                                } else {
                                    $ci_propre = $cols[$c];
                                }
                                
                                $ci_propre = interdire_scripts(propre($ci_propre));
                                
                                if ($ci_pos_moins!==false){
                                    $ci_propre = str_replace("&ndash;","-",$ci_propre);
                                    $ci_propre = str_replace("&amp;ndash;","-",$ci_propre);
                                }
                                
                                // pas de paragraphe pour l'ensemble
                                if (substr($ci_propre,0,3)=='<p>' AND substr($ci_propre,-4)=='</p>'){
                                    $ci_propre = substr($ci_propre,3,-4);
                                }
				$ligne = "\n<$b" . $attr . '>' . $ci_propre . "</$b>" . $ligne;
			}
		}

		// ligne complete
		$class = alterner($l + 1, 'odd', 'even');
		$html = "<tr class='row_$class $class'>$ligne</tr>\n$html";
	}
        
        $class_table = " class='spip'";
        if ($GLOBALS['spip_version_branche']>=4) {
            $class_table = " class='table spip'";
        }
        
	return "\n\n<table" . $class_table . $summary . ">\n"
	. $debut_table
	. "<tbody>\n"
	. $html
	. "</tbody>\n"
	. "</table>\n\n";
}

function ciwidget_optimise_donnees_json($data=''){
    if (empty($data)){
        return '';
    }
    
    // enlever les colonnes vides
    $data_extrait = '';
    $pos = strpos($data,'],[');
    $extrait = substr($data,0,$pos);
    $nombre_total_de_colonnes = substr_count($extrait,',')+1;
    $extrait = str_replace(',""','',$extrait);
    $nombre_colonnes = substr_count($extrait,',')+1;
    $nombre_colonnes_vides = $nombre_total_de_colonnes - $nombre_colonnes;
    $cherche = ',""]';
    for ($i = 2; $i <= $nombre_colonnes_vides; $i++) {
        $cherche = ',""'.$cherche;
    }

    if ($nombre_colonnes_vides>=1){
        $data_extrait = str_replace($cherche,']',$data);
    } else {
        $data_extrait = $data;
    }

    // enlever les lignes vides
    $cherche = ',[""';
    for ($i = 2; $i <= $nombre_colonnes; $i++) {
        $cherche .= ',""';
    }
    $cherche .= ']';
    
    return str_replace($cherche,'',$data_extrait);
}

?>