<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');

function formulaires_ciwidget_videoterra_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
	if (!autoriser('modifier',$objet,$id_objet))
		return false;

        $valeurs = array('titre'=>'','descriptif'=>'','credits'=>'','code'=>'','duree'=>'00:00:00','largeur'=>'640');
        
        $id_widget = intval($id_widget);
	if ($id_widget>0) {
		$result = sql_select("*", "spip_ciwidget", "id_widget=$id_widget");
		while ($row = sql_fetch($result)) { 
			$valeurs = $row;
		}
        
                // anti hack
                if (isset($valeurs['type_widget']) AND $valeurs['type_widget']!='videoterra'){
                    return false;
                }
                
                // unserialize le champ contenu
                if (isset($valeurs['contenu'])){
                    $contenu = unserialize($valeurs['contenu']);
                    $valeurs['contenu'] = '';
                    if ($contenu AND is_array($contenu)){
                        $valeurs = array_merge($valeurs,$contenu);
                    }
                    if (isset($valeurs['duree'])){
                        $valeurs['duree'] = date('H:i:s', mktime(0, 0, intval($valeurs['duree'])));
                    }
                }
	}
        
        $valeurs['retour_objet'] = ciwidget_retour_vers_objet($objet, $id_objet);

	return $valeurs;
}

function formulaires_ciwidget_videoterra_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $erreurs = array();
        
	$titre = _request('titre');	
	if (!$titre){
		$erreurs['titre'] = _T('info_obligatoire');
        }
        
	$code = _request('code');	
	if (!$code){
		$erreurs['code'] = _T('info_obligatoire');
        } elseif (!ci_videoterra_verifier_id($code)) {
		$erreurs['code'] = _T('ciwidget:valeur_incorrecte');
        }
        
	if (ciwidget_erreur_duree(_request('duree'))){
            $erreurs['duree'] = ciwidget_erreur_duree(_request('duree'));
        }	
        
	return $erreurs;
}

function formulaires_ciwidget_videoterra_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $id_widget = intval($id_widget);

        $c = array();
	foreach (array('titre', 'descriptif') as $champ){
		$c[$champ] = _request($champ);
        }
        
        $code = _request('code');
        $largeur = ciwidget_verif_largeur_sinon_defaut(_request('largeur'), 640);
        $duree = 0;
        if (preg_match('#([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})#', _request('duree'), $regs)) {
             $duree = (3600*intval($regs[1])) + (60*intval($regs[2])) + intval($regs[3]);
        }
        $credits = _request('credits');
        
        $type_widget = 'videoterra';
        $c['contenu'] = serialize(array('code'=>$code, 'duree'=>$duree, 'largeur'=>$largeur, 'credits'=>$credits));
        $c['type_widget'] = $type_widget;
        $c['objet'] = $objet;
        $c['id_objet'] = $id_objet;

	if ($id_widget>0) {
            // modifier
            sql_updateq("spip_ciwidget", $c, "id_widget=$id_widget");
        } else {
            // ajouter et lier
            $id_widget = sql_insertq('spip_ciwidget', $c);
        }
    
        $res = ciwidget_retour_formulaire($objet,$id_objet,$type_widget,$retour);

	return $res;
}

function ci_videoterra_verifier_id($code){
    $return = '';
    $debut = strpos($code,"src='https://terra.developpement-durable.gouv.fr/LaMediatheque-Video/embed/");
    
    if ($debut>0){
        $extrait = substr($code,$debut+75);
        $fin = strpos($extrait,"'");
        if ($fin>0){
            $extrait = substr($extrait, 0, $fin);
            $extrait = str_replace('public/','',$extrait);
            $return = intval($extrait);
        }
    }    
    
    return $return;
}

?>