<?php
/**
 * Plugin CIWIDGET 
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/ciwidget_inc_style');


function ciwidget_css_citation(){
    
$return = '/* Widget citation */

.ciwidget_citation {
    margin:1rem 0;
    clear: both;
    '.ciwidget_ligne_css('citation','bloc_background-color').'
    '.ciwidget_ligne_css('citation','bloc_border-style').'
    '.ciwidget_ligne_css('citation','bloc_border-color').'
    '.ciwidget_ligne_css('citation','bloc_border-width').'
    '.ciwidget_ligne_css('citation','bloc_border-radius').'
    '.ciwidget_ligne_css('citation','bloc_padding').'
    '.ciwidget_ligne_css('citation','bloc_max-width').'
    '.ciwidget_ligne_css('citation','bloc_text-align').'
}
.ciwidget_citation figure {
    position: relative;
    margin-bottom: 0;
    '.ciwidget_ligne_css('citation','bloc_text-align').'
}
';

if (ciwidget_lire_meta_cle('citation','affichericone')=='oui'){
$return .= '
.ciwidget_citation figure:before {
    display:block;
    -webkit-mask-image:url(data:image/svg+xml;base64,'.ciwidget_valeur_mask_image('citation','icone1_mask-image').');
    mask-image:url(data:image/svg+xml;base64,'.ciwidget_valeur_mask_image('citation','icone1_mask-image').');
    -webkit-mask-size:100% 100%;
    mask-size:100% 100%;
    height:'.ciwidget_valeur_css('citation','icone1_icon-size').';
    width:'.ciwidget_valeur_css('citation','icone1_icon-size').';
    content:"";
    '.ciwidget_ligne_css('citation','icone1_color','icone1_background-color').'
    '.ciwidget_ligne_css('citation','icone1_margin-bottom').'
}
';
}

$ci_figure_bord_couleur = ciwidget_valeur_css('citation','figure_border-color');
$ci_figure_bord_largeur = ciwidget_valeur_css('citation','figure_border-left-width');

if ($ci_figure_bord_couleur AND $ci_figure_bord_largeur){
$return .= '
.ciwidget_citation_figure {
 background-image:linear-gradient(0deg,'.$ci_figure_bord_couleur.','.$ci_figure_bord_couleur.');
 background-position:.5rem 100%;
 background-repeat:no-repeat;
 background-size:50% '.$ci_figure_bord_largeur.';
 margin:0;
 padding:0 .5rem 2rem;
}
';
}

$return .= '
.ciwidget_citation_figure {
  display: flex;
  flex-direction: column;
  align-items: flex-start;
  justify-content: center;
}

.ciwidget_citation_figure figcaption {
  min-height: 4.25rem;
  display: flex;
  flex-direction: column;
  align-items: flex-start;
  justify-content: center;
}

.ciwidget_citation blockquote {
  /* desactiver style par defaut */
    min-height: 2rem;
    background: none;
    border: none;
    padding: 0;  
    margin: 0;
    
    '.ciwidget_ligne_css('citation','texte_font-family').'
    '.ciwidget_ligne_css('citation','texte_font-size').'
    '.ciwidget_ligne_css('citation','texte_line-height').'
    '.ciwidget_ligne_css('citation','texte_font-weight').'
    '.ciwidget_ligne_css('citation','texte_font-style').'
    '.ciwidget_ligne_css('citation','texte_margin-bottom').'
}

.ciwidget_citation blockquote p {
  /* desactiver style par defaut */
    padding: 0;  
    margin: 0;
}

.ciwidget_citation__auteur {
    '.ciwidget_ligne_css('citation','auteur_font-family').'
    '.ciwidget_ligne_css('citation','auteur_font-size').'
    '.ciwidget_ligne_css('citation','auteur_line-height').'
    '.ciwidget_ligne_css('citation','auteur_font-weight').'
    '.ciwidget_ligne_css('citation','auteur_margin-bottom').'
}

.ciwidget_citation cite {
    '.ciwidget_ligne_css('citation','source_font-family').'
    '.ciwidget_ligne_css('citation','source_font-size').'
    '.ciwidget_ligne_css('citation','source_line-height').'
    '.ciwidget_ligne_css('citation','source_font-weight').'
    '.ciwidget_ligne_css('citation','ouvrage_font-style').'        
}

.ciwidget_citation figcaption {
    '.ciwidget_ligne_css('citation','source_margin-bottom').'
}

.ciwidget_citation figcaption ul {
    margin-bottom: 0px;
    list-style-type: none;
}

.ciwidget_citation figcaption li {
    '.ciwidget_ligne_css('citation','source_font-family').'
    '.ciwidget_ligne_css('citation','source_font-size').'
    '.ciwidget_ligne_css('citation','source_line-height').'
    '.ciwidget_ligne_css('citation','source_font-weight').'
}

.ciwidget_citation__image {
    display:none;
}

.ciwidget_citation figcaption .ciwidget_citation__source {
  display: flex;
  flex-direction: row;
  justify-content: flex-start;
  flex-wrap: wrap;
}

.ciwidget_citation figcaption .ciwidget_citation__source li {
  display: inline-block;
}

.ciwidget_citation figcaption .ciwidget_citation__source li:not(:last-child)::after {
  content: "·";
  display: inline-block;
  padding-left: 0.25rem;
  padding-right: 0.25rem;
}

.ciwidget_citation .quote_debut {
    '.ciwidget_ligne_css('citation','quote_font-size').'
    '.ciwidget_ligne_css('citation','quote_line-height').'
    '.ciwidget_ligne_css('citation','quote_font-weight').'
    '.ciwidget_ligne_css('citation','quote_padding-right').'
}

.ciwidget_citation .quote_fin {
    '.ciwidget_ligne_css('citation','quote_font-size').'
    '.ciwidget_ligne_css('citation','quote_line-height').'
    '.ciwidget_ligne_css('citation','quote_font-weight').'
    '.ciwidget_ligne_css('citation','quote_padding-left').'
}

@media (min-width: 48em) {

    .ciwidget_citation_figure {
        margin-left: calc(1.5rem + '.ciwidget_valeur_css('citation','image_width').');
        min-height: calc(1.5rem + '.ciwidget_valeur_css('citation','image_height').');
    }

    .ciwidget_citation_figure_sans_vignette {
        margin-left: 0rem;
        min-height: 0rem;
    }

    .ciwidget_citation_figure figcaption {
        min-height: auto;
    }

    .ciwidget_citation__image {
        position: absolute;
        display: flex;
        flex-direction: row;
        top: 50%;
        '.ciwidget_ligne_css('citation','image_width').'
        '.ciwidget_ligne_css('citation','image_height').'
        left: calc(-1.5rem - '.ciwidget_valeur_css('citation','image_width').');
        margin-top: calc(-1 * ('.ciwidget_valeur_css('citation','image_height').' / 2));
        background-size: cover;
        overflow: hidden;
        '.ciwidget_ligne_css('citation','image_border-radius').'
    }

    .ciwidget_citation__image img {
        width: 100%;
        height: 100%;
    }

}
';

if ($ci_figure_bord_couleur AND $ci_figure_bord_largeur){
$return .= '

@media (min-width: 48em) {
   .ciwidget_citation_figure {
      background-position: 0 0;
      background-size: '.$ci_figure_bord_largeur.' 100%;
      padding: 0 0 0 2rem;
    }
}
';
}
    
    return $return;
}

?>